function Data = gen(size)
% Function to generate the 3-state model from Ron et al's original paper.
% This function creates a noisy version of the model. The current state
% will always have a probability value > 0.5.

Data={};
state = ceil(rand*3);
Data{1}  = rand(2,size)/3;

for i=1:size
  if ((state==1) && (rand<0.9)) 
     state = 1;
     Data{1}(1,i) = (rand/4)+0.75;
  elseif (state==1)
     state = 2;
     Data{1}(2,i) = (rand/4)+0.75;
  elseif ((state==2) && (rand<0.7))
     state = 2;
     Data{1}(2,i) = (rand/4)+0.75;
  elseif (state==2)
     state = 3;
     Data{1}(1,i) = (rand/4)+0.75;
  elseif ((state==3) && (rand<0.6))
     state=1;
     Data{1}(1,i) = (rand/4)+0.75;
  elseif (state==3)
     state = 2;
     Data{1}(2,i) = (rand/4)+0.75;
  end;
end;

% Normalise cols of Data
for i=1:size
  Data{1}(:,i) = Data{1}(:,i) / sum(Data{1}(:,i));
end;

% END OF FILE 